org.apache.bcel.classfile

## Class SourceFile

- java.lang.Object
- - org.apache.bcel.classfile.Attribute
  - - org.apache.bcel.classfile.SourceFile

- All Implemented Interfaces:
    Cloneable, Node

      public final class SourceFile
      extends Attribute

  This class is derived from Attribute and represents a reference to the source file of this class. At most one SourceFile attribute should appear per classfile. The intention of this class is that it is instantiated from the Attribute.readAttribute() method.
  Version:
    $Id: SourceFile.java 1749603 2016-06-21 20:50:19Z ggregory $
  See Also:
    `Attribute`

- - ### Field Summary

    - ### Fields inherited from class org.apache.bcel.classfile.Attribute

      `constant_pool, length, name_index, tag`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SourceFile(int name_index, int length, int sourcefile_index, ConstantPool constant_pool)`
    `SourceFile(SourceFile c)` Initialize from another object.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `accept(Visitor v)` Called by objects that are traversing the nodes of the tree implicitely defined by the contents of a Java class.
    `Attribute` | `copy(ConstantPool _constant_pool)`
    `void` | `dump(DataOutputStream file)` Dump source file attribute to file stream in binary format.
    `int` | `getSourceFileIndex()`
    `String` | `getSourceFileName()`
    `void` | `setSourceFileIndex(int sourcefile_index)`
    `String` | `toString()`

    - ### Methods inherited from class org.apache.bcel.classfile.Attribute

      `addAttributeReader, addAttributeReader, clone, getConstantPool, getLength, getName, getNameIndex, getTag, readAttribute, readAttribute, removeAttributeReader, setConstantPool, setLength, setNameIndex`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### SourceFile

          public SourceFile(SourceFile c)

      Initialize from another object. Note that both objects use the same references (shallow copy). Use clone() for a physical copy.

    - #### SourceFile

          public SourceFile(int name_index,
                            int length,
                            int sourcefile_index,
                            ConstantPool constant_pool)

      Parameters:
        `name_index` - Index in constant pool to CONSTANT_Utf8, which should represent the string "SourceFile".
        `length` - Content length in bytes, the value should be 2.
        `constant_pool` - The constant pool that this attribute is associated with.
        `sourcefile_index` - Index in constant pool to CONSTANT_Utf8. This string will be interpreted as the name of the file from which this class was compiled. It will not be interpreted as indicating the name of the directory contqining the file or an absolute path; this information has to be supplied the consumer of this attribute - in many cases, the JVM.

  - ### Method Detail

    - #### accept

          public void accept(Visitor v)

      Called by objects that are traversing the nodes of the tree implicitely defined by the contents of a Java class. I.e., the hierarchy of methods, fields, attributes, etc. spawns a tree of objects.
      Specified by:
        `accept` in interface `Node`
      Specified by:
        `accept` in class `Attribute`
      Parameters:
        `v` - Visitor object

    - #### dump

          public final void dump(DataOutputStream file)
                          throws IOException

      Dump source file attribute to file stream in binary format.
      Overrides:
        `dump` in class `Attribute`
      Parameters:
        `file` - Output file stream
      Throws:
        `IOException`

    - #### getSourceFileIndex

          public final int getSourceFileIndex()

      Returns:
        Index in constant pool of source file name.

    - #### setSourceFileIndex

          public final void setSourceFileIndex(int sourcefile_index)

      Parameters:
        `sourcefile_index` -

    - #### getSourceFileName

          public final String getSourceFileName()

      Returns:
        Source file name.

    - #### toString

          public final String toString()

      Overrides:
        `toString` in class `Attribute`
      Returns:
        String representation

    - #### copy

          public Attribute copy(ConstantPool _constant_pool)

      Specified by:
        `copy` in class `Attribute`
      Returns:
        deep copy of this attribute

Copyright © 2004–2019 The Apache Software Foundation. All rights reserved.